* MEDIATE for SAS;
* Written by Andrew F. Hayes;
* Download documentation at;
* http://www.afhayes.com/;
* Use at your own risk;

%macro bcboot (databcbt=,estmte=9999);
temp=&databcbt;
temp[rank(temp)]=&databcbt;
badlo=0;
badhi=0;
if (&estmte ^= 9999) then;
  do;pv=(temp < &estmte);pv=pv[+]/reps;
  ppv=pv;
  if (pv > 0.5) then;do;ppv=1-pv;end;
  y5=sqrt(-2*log(ppv));
  xp=y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0);
  if (pv <= .5) then;do;xp=-xp;end;
  cilow=floor(reps*(probnorm(2*xp+xp2)));
  cihigh=floor(reps*(probnorm(2*xp+(-xp2))))+1;
  if (cilow < 1) then;do;cilow=1;booterr=1;badlo=1;end;
  if (cihigh > boot) then;do;cihigh=boot;booterr=1;badhi=1;end;
  llcit=temp[cilow,1];
  ulcit=temp[cihigh,1];
  end;
if (&estmte=9999) then;do;llcit=temp[cilow,1];ulcit=temp[cihigh,1];end;
%mend;

%macro mediate (data=,y=,m=,x=,c=,samples=1000,ciconf=95,cimethod=1,omnibus=0,
  total=0,catx=0,seed=0,percent=0);
options pagesize=32767;
proc iml;
use &data;
read all var{&y &x &m &c} into dd;
name={&y &x &m &c};
y=dd[,1];
ninit=nrow(dat);
xx=(dd = .);xx=xx[,+];
j=1;do i = 1 to nrow(dd);if xx[i,1]=0 then;do;dd[j,]=dd[i,];j=j+1;end;end;
dd=dd[1:j-1,];
method=&cimethod;bconoff=(&percent ^= 1);percent=(&percent ^= 0);
samples=&samples;omnibus=&omnibus;
booterr=0;stratify=0;conf=&ciconf;
catx=floor(&catx);
if ((catx < 0) | (catx > 4)) then;do;catx=1;end;
ovals=1;
  do jj=1 to ninit;
    if ((dd[jj,1] ^= max(y)) & (dd[jj,1] ^= min(y))) then;do;ovals=0;
    end;
  end;
nte=1;criterr=0;note=j(50,1,0);adjust=0;xskip=0;dumok=0;badend=0;
p0=-.322232431088;
p1 = -1;
p2 = -.342242088547;
p3 = -.0204231210245;
p4 = -.0000453642210148;
q0 = .0993484626060;
q1 = .588581570495;
q2 = .531103462366;
q3 = .103537752850;
q4 = .0038560700634;
alpha2=(1-(conf/100))/2;
y5=sqrt(-2*log(alpha2));
xp2=-(y5+((((y5*p4+p3)*y5+p2)*y5+p1)*y5+p0)/((((y5*q4+q3)*y5+q2)*y5+q1)*y5+q0));
priorlo=-9999999;priorhi=9999999;
ddd={"D1" "D2" "D3" "D4" "D5" "D6" "D7" "D8" "D9"};
if ((floor(conf) >= 100) | (floor(conf) < 50)) then;do;conf=95;end;
total = &total;reps=samples;errs=0;
runerrs=j(50,1,0);
if (ovals < 3) then;do;errs=errs+1;runerrs[errs,1]=6;criterr=1;end;
if (method = 2) then;do;
  if (omnibus=1) then;do;
    note[nte,1]=5;nte=nte+1;
  end;
  samples=0;
  if (reps < 1000) then;do;
    reps=1000;
  end;
end;
if (reps ^= 0) then;do;
  cilow=floor(reps*(1-(conf/100))/2);cihigh=floor((reps*(conf/100)+(reps*(1-(conf/100))/2)))+1;
  do until ((cilow > 0) & (cihigh <= reps));
    cilow=floor(reps*(1-(conf/100))/2);cihigh=floor((reps*(conf/100)+(reps*(1-(conf/100))/2)))+1;
    if ((cilow < 1) | (cihigh > reps)) then;do;reps=floor((boot+1000)/1000)*1000;adjust=1;
    end;
  end;
  if (adjust = 1) then;do;note[notes,1]=6;notes=notes+1;
  end;
end;
if (method = 1) then;do;samples=reps;
temp=ncol(dd);





end;
quit;
options pagesize=54;
%mend;
